function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import { css } from '@patternfly/react-styles';
import { DropdownContext } from './dropdownConstants';
const propTypes = {
  /** Checkboxes within group */
  children: PropTypes.node,

  /** Additional classes added to the DropdownGroup control */
  className: PropTypes.string,

  /** Group label */
  label: PropTypes.node,

  /** Additional props are spread to the container <div> */
  '': PropTypes.any // eslint-disable-line react/require-default-props

};
const defaultProps = {
  children: null,
  className: '',
  label: ''
};

const DropdownGroup = (_ref) => {
  let {
    children,
    className,
    label
  } = _ref,
      props = _objectWithoutProperties(_ref, ["children", "className", "label"]);

  return React.createElement(DropdownContext.Consumer, null, ({
    sectionClass,
    sectionTitleClass,
    sectionComponent: SectionComponent
  }) => React.createElement(SectionComponent, _extends({}, props, {
    className: css(sectionClass, className)
  }), label && React.createElement("h1", {
    className: css(sectionTitleClass),
    "aria-hidden": true
  }, label), React.createElement("ul", {
    role: "none"
  }, children)));
};

DropdownGroup.propTypes = propTypes;
DropdownGroup.defaultProps = defaultProps;
export default DropdownGroup;
//# sourceMappingURL=DropdownGroup.js.map