function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { css } from '@patternfly/react-styles';
import styles from '@patternfly/react-styles/css/layouts/Bullseye/bullseye';
import PropTypes from 'prop-types';
import { componentShape } from '../../helpers/componentShape';
const propTypes = {
  /** content rendered inside the Bullseye layout */
  children: PropTypes.any,

  /** additional classes added to the Bullseye layout */
  className: PropTypes.string,

  /** Sets the base component to render. defaults to div */
  component: componentShape,

  /** Additional props are spread to the container component */
  '': PropTypes.any // eslint-disable-line react/require-default-props

};
const defaultProps = {
  children: null,
  className: '',
  component: 'div'
};

const Bullseye = (_ref) => {
  let {
    children,
    className,
    component: Component
  } = _ref,
      props = _objectWithoutProperties(_ref, ["children", "className", "component"]);

  return React.createElement(Component, _extends({
    className: css(styles.bullseye, className)
  }, props), children);
};

Bullseye.propTypes = propTypes;
Bullseye.defaultProps = defaultProps;
export default Bullseye;
//# sourceMappingURL=Bullseye.js.map