import * as React from 'react';
export declare const AccordionContext: React.Context<string>;
export interface AccordionProps extends React.HTMLProps<HTMLDListElement> {
    /** Content rendered inside the Accordion  */
    children?: React.ReactNode;
    /** Additional classes added to the Accordion  */
    className?: string;
    /** Adds accessible text to the Accordion */
    'aria-label'?: string;
    /** the heading level to use */
    headingLevel?: 'h1' | 'h2' | 'h3' | 'h4' | 'h5' | 'h6';
}
export declare const Accordion: React.FunctionComponent<AccordionProps>;
