"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactStyles = require("@patternfly/react-styles");

var _dropdownConstants = require("./dropdownConstants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var propTypes = {
  /** Checkboxes within group */
  children: _propTypes["default"].node,

  /** Additional classes added to the DropdownGroup control */
  className: _propTypes["default"].string,

  /** Group label */
  label: _propTypes["default"].node,

  /** Additional props are spread to the container <div> */
  '': _propTypes["default"].any // eslint-disable-line react/require-default-props

};
var defaultProps = {
  children: null,
  className: '',
  label: ''
};

var DropdownGroup = function DropdownGroup(_ref) {
  var children = _ref.children,
      className = _ref.className,
      label = _ref.label,
      props = _objectWithoutProperties(_ref, ["children", "className", "label"]);

  return _react["default"].createElement(_dropdownConstants.DropdownContext.Consumer, null, function (_ref2) {
    var sectionClass = _ref2.sectionClass,
        sectionTitleClass = _ref2.sectionTitleClass,
        SectionComponent = _ref2.sectionComponent;
    return _react["default"].createElement(SectionComponent, _extends({}, props, {
      className: (0, _reactStyles.css)(sectionClass, className)
    }), label && _react["default"].createElement("h1", {
      className: (0, _reactStyles.css)(sectionTitleClass),
      "aria-hidden": true
    }, label), _react["default"].createElement("ul", {
      role: "none"
    }, children));
  });
};

DropdownGroup.propTypes = propTypes;
DropdownGroup.defaultProps = defaultProps;
var _default = DropdownGroup;
exports["default"] = _default;
//# sourceMappingURL=DropdownGroup.js.map