"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NotificationBadge = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var React = _interopRequireWildcard(require("react"));

var _Button = require("../Button");

var _reactStyles = require("@patternfly/react-styles");

var _notificationBadge = _interopRequireDefault(require("@patternfly/react-styles/css/components/NotificationBadge/notification-badge"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var NotificationBadge = function NotificationBadge(_ref) {
  var _ref$isRead = _ref.isRead,
      isRead = _ref$isRead === void 0 ? false : _ref$isRead,
      className = _ref.className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ["isRead", "className", "children"]);

  return React.createElement(_Button.Button, _extends({
    variant: _Button.ButtonVariant.plain,
    className: className
  }, props), React.createElement("span", {
    className: (0, _reactStyles.css)(_notificationBadge["default"].notificationBadge, isRead ? _notificationBadge["default"].modifiers.read : _notificationBadge["default"].modifiers.unread)
  }, children));
};

exports.NotificationBadge = NotificationBadge;
NotificationBadge.propTypes = {
  isRead: _propTypes["default"].bool,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  'aria-label': _propTypes["default"].string
};
//# sourceMappingURL=NotificationBadge.js.map