import * as React from 'react';
export interface SelectContextInterface {
    onSelect: (event: React.MouseEvent<any, MouseEvent> | React.ChangeEvent<HTMLInputElement>, value: string, isPlaceholder?: boolean) => void;
    onClose: () => void;
    variant: string;
}
export declare const SelectContext: React.Context<SelectContextInterface>;
export declare const SelectProvider: React.ProviderExoticComponent<React.ProviderProps<SelectContextInterface>>;
export declare const SelectConsumer: React.ExoticComponent<React.ConsumerProps<SelectContextInterface>>;
export declare enum SelectVariant {
    single = "single",
    checkbox = "checkbox",
    typeahead = "typeahead",
    typeaheadMulti = "typeaheadmulti"
}
export declare const KeyTypes: {
    Tab: string;
    Space: string;
    Escape: string;
    Enter: string;
    ArrowUp: string;
    ArrowDown: string;
};
