(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "prop-types", "react", "@patternfly/react-styles", "@patternfly/react-styles/css/components/AboutModalBox/about-modal-box", "@patternfly/react-styles/css/components/Content/content"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("prop-types"), require("react"), require("@patternfly/react-styles"), require("@patternfly/react-styles/css/components/AboutModalBox/about-modal-box"), require("@patternfly/react-styles/css/components/Content/content"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.propTypes, global.react, global.reactStyles, global.aboutModalBox, global.content);
    global.undefined = mod.exports;
  }
})(this, function (exports, _propTypes, _react, _reactStyles, _aboutModalBox, _content) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.AboutModalBoxContent = undefined;

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var React = _interopRequireWildcard(_react);

  var _aboutModalBox2 = _interopRequireDefault(_aboutModalBox);

  var _content2 = _interopRequireDefault(_content);

  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};

      if (obj != null) {
        for (var key in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {};

            if (desc.get || desc.set) {
              Object.defineProperty(newObj, key, desc);
            } else {
              newObj[key] = obj[key];
            }
          }
        }
      }

      newObj.default = obj;
      return newObj;
    }
  }

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  ;

  const AboutModalBoxContent = exports.AboutModalBoxContent = _ref => {
    let {
      children,
      className = '',
      trademark,
      id,
      noAboutModalBoxContentContainer = false
    } = _ref,
        props = _objectWithoutProperties(_ref, ["children", "className", "trademark", "id", "noAboutModalBoxContentContainer"]);

    return React.createElement("div", _extends({
      className: (0, _reactStyles.css)(_aboutModalBox2.default.aboutModalBoxContent, className),
      id: id
    }, props), React.createElement("div", {
      className: (0, _reactStyles.css)('pf-c-about-modal-box__body')
    }, noAboutModalBoxContentContainer ? children : React.createElement("div", {
      className: (0, _reactStyles.css)(_content2.default.content)
    }, children)), React.createElement("p", {
      className: (0, _reactStyles.css)(_aboutModalBox2.default.aboutModalBoxStrapline)
    }, trademark));
  };

  AboutModalBoxContent.propTypes = {
    children: _propTypes2.default.node.isRequired,
    className: _propTypes2.default.string,
    id: _propTypes2.default.string.isRequired,
    trademark: _propTypes2.default.string.isRequired,
    noAboutModalBoxContentContainer: _propTypes2.default.bool
  };
});
//# sourceMappingURL=AboutModalBoxContent.js.map