(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "react", "prop-types", "@patternfly/react-styles", "./dropdownConstants"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("react"), require("prop-types"), require("@patternfly/react-styles"), require("./dropdownConstants"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.propTypes, global.reactStyles, global.dropdownConstants);
    global.undefined = mod.exports;
  }
})(this, function (exports, _react, _propTypes, _reactStyles, _dropdownConstants) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  const propTypes = {
    /** Checkboxes within group */
    children: _propTypes2.default.node,

    /** Additional classes added to the DropdownGroup control */
    className: _propTypes2.default.string,

    /** Group label */
    label: _propTypes2.default.node,

    /** Additional props are spread to the container <div> */
    '': _propTypes2.default.any // eslint-disable-line react/require-default-props

  };
  const defaultProps = {
    children: null,
    className: '',
    label: ''
  };

  const DropdownGroup = _ref => {
    let {
      children,
      className,
      label
    } = _ref,
        props = _objectWithoutProperties(_ref, ["children", "className", "label"]);

    return _react2.default.createElement(_dropdownConstants.DropdownContext.Consumer, null, ({
      sectionClass,
      sectionTitleClass,
      sectionComponent: SectionComponent
    }) => _react2.default.createElement(SectionComponent, _extends({}, props, {
      className: (0, _reactStyles.css)(sectionClass, className)
    }), label && _react2.default.createElement("h1", {
      className: (0, _reactStyles.css)(sectionTitleClass),
      "aria-hidden": true
    }, label), _react2.default.createElement("ul", {
      role: "none"
    }, children)));
  };

  DropdownGroup.propTypes = propTypes;
  DropdownGroup.defaultProps = defaultProps;
  exports.default = DropdownGroup;
});
//# sourceMappingURL=DropdownGroup.js.map